import numpy as np
import pandas as pd
from typing import Any, Dict, Optional


def model_to_df(list_obj):
    final = []
    for i in list_obj:
        new_i = {}
        for key, item in i.dict().items():
            if isinstance(item, dict):
                for n_k, n_i in item.items():
                    new_i.update({f"{key}_{n_k}": n_i})
            else:
                new_i.update({key: item})
        final.append(new_i)
    return pd.DataFrame(final)


def aggregate_groups(
    grouped_obj: Dict[str, Any] = {},
    # this can be any flat field
    field: Optional[str] = "contribution"
):
    """
    group wide figures for selected grouping field, by scope and for selected method and attribution
    """
    grp_sum = {}
    for grp, companies in grouped_obj.items():
        grp_sum[grp] = round(np.nanmean([
            c[field]
            for c in companies]
        ), 2)
    return grp_sum
